Bug 143052 - CAN-2004-1287 Bernstein class reports buffer overflow in nasm
CAN-2004-1287 Bernstein class reports buffer overflow in nasm
Status: CLOSED ERRATA
Product: Fedora
Classification: Fedora
Component: nasm (Show other bugs)
3
All Linux
medium Severity low
: ---
: ---
Assigned To: Richard Henderson
Brian Brock
impact=low,public=20041215,source=bug...
: Security
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2004-12-15 19:00 EST by Alan Cox
Modified: 2007-11-30 17:10 EST (History)
1 user (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2005-08-20 02:56:16 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)

  None (edit)
Description Alan Cox 2004-12-15 19:00:17 EST
http://tigger.uic.edu/~jlongs2/holes/nasm.txt

Jonathan Rockway, a student in my Fall 2004 UNIX Security Holes course,
has discovered a remotely exploitable security hole in NASM. I'm
publishing this notice, but all the discovery credits should be assigned
to Rockway.

You are at risk if you receive an asm file from an email message (or a
web page or any other source that could be controlled by an attacker)
and feed that file through NASM. Whoever provides that asm file then has
complete control over your account: he can read and modify your files,
watch the programs you're running, etc.

Of course, if you _run_ a program, you're authorizing the programmer to
take control of your account; but the NASM documentation does not say
that merely _assembling_ a program can have this effect. It's easy to
imagine situations in which a program is run inside a jail but assembled
outside the jail; this NASM bug means that the jail is ineffective.

Proof of concept: On an x86 computer running FreeBSD 4.10, as root, type

   cd /usr/ports/devel/nasm
   make install

to download and compile the NASM program, version 0.98.38 (current).
Then, as any user, save the file 22.S attached to this message, and type

   nasm 22.S

with the unauthorized result that a file named EXPLOITED is created in
the current directory. (I tested this with a 525-byte environment, as
reported by printenv | wc -c.)

Here's the bug: In preproc.c, error() uses an unprotected vsprintf() to
copy data into a 1024-byte buff[] array.

---D. J. Bernstein, Associate Professor, Department of Mathematics,
Statistics, and Computer Science, University of Illinois at Chicago

    [ Part 2, Text/PLAIN (charset: unknown-8bit)  54 lines. ]
    [ Unable to print this part. ]
Comment 1 Josh Bressers 2004-12-16 08:09:30 EST
This issue also affects FC2
Comment 2 Jindrich Novy 2005-04-15 09:06:51 EDT
Fix is now applied in FC3 and patch for this is attached to fedora-legacy bug
for this to let it be fixed in FC2.
Comment 3 Marius Andreiana 2005-08-20 02:56:16 EDT
nasm-0.98.38-3.FC3.i386.rpm was released in updates. Closing.

Note You need to log in before you can comment on or make changes to this bug.